#include <sys/stat.h>

#include "config.h"

typedef union {
	struct sockaddr sa;
	struct sockaddr_in sa_in;
} httpd_sockaddr;

/*  ü */
typedef struct {
	int port;
	int listen_fd;
} httpd_server;

/* Ŭ̾Ʈ  ü */
typedef struct {
	httpd_sockaddr client_addr;
	int conn_fd;
	char* hostname;
	char* method;
	int status;

	char* read_buf;
	long int read_size, read_idx, send_idx;
	int keep_alive;
	int one_one;
	int sendstart;
	char* encodedurl;
	char* decodedurl;
	char* origfilename;
	char* referer;
	int file;
	struct stat filestat;
	time_t now;

	int contentlength;
	char* accept;
	char* accepte;
	char* encodings;
	char* protocol;
	char* query;
	char* useragent;
	char* cookie;
	char* contenttype;
} httpd_conn;

typedef struct {
	int conn_state;
	httpd_conn* hc;
} connecttab;



extern httpd_server* httpd_initialize( httpd_sockaddr* sa, int port );
extern int initialize_listen_socket( httpd_sockaddr* sa );
extern void free_httpd_server( httpd_server* hs );
extern void clear_client( connecttab* connects, int cnum, int* numconnects );
extern int httpd_get_conn( int listen_fd, connecttab* connects, int cnum );
extern void conn_free( httpd_conn* hc );
extern void conn_init( httpd_conn* hc );
extern char* getbuf( httpd_conn* hc );
extern void strdecode( char* to, char* from );
extern int hexit( char c );
extern void de_dotdot( char* file );
extern int httpd_start_request( httpd_conn* hc );
extern char* make_header( httpd_conn* hc );
extern char *status_code( int status );


